routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('password/reset','Auth\ForgotPasswordController@showLinkRequestForm')
    ->name('password.request');
Route::post('password/email','Auth\ForgotPasswordController@sendResetLinkEmail')
    ->name('password.email');
Route::get('password/reset/token','Auth\ResetPasswordController@showResetForm')
    ->name('password.reset');
Route::post('password/reset','Auth\ResetPasswordController@reset');

Route::get('email-verification/error', 'EmailVerificationController@getVerificationError')->name('email-verification.error');
Route::get('email-verification/check/{token}', 'EmailVerificationController@getVerification')->name('email-verification.check');

Route::get('/home', 'HomeController@index')->name('home');

Route::group([
    'prefix'=>'admin',
    'as'=>'admin.',
    'namespace' => 'Admin\\'
],function(){
    Route::name('login')->get('login','Auth\LoginController@showLoginForm');
    Route::post('login','Auth\LoginController@login');

    Route::group(['middleware'=>['isVerified','can:admin']], function () {
        Route::name('logout')->post('logout','Auth\LoginController@logout');
        Route::get('dashboard',function(){
            return view('admin.dashboard');
        })->name('dashboard');
        Route::name('user_settings.edit')->get('users/settings','Auth\UserSettingsController@edit');
        Route::name('user_settings.update')->put('users/settings','Auth\UserSettingsController@update');
        Route::resource('users','UsersController');
        Route::resource('categories','CategoriesController');
        Route::resource('plans','PlansController');
        Route::resource('web_profiles','PaypalWebProfilesController');

        Route::get('series/{serie}/thumb_asset','SeriesController@thumbAsset')->name('series.thumb_asset');
        Route::get('series/{serie}/thumb_small_asset','SeriesController@thumbSmallAsset')->name('series.thumb_small_asset');
        Route::resource('series','SeriesController');
        Route::group(['prefix'=>'videos','as'=>'videos.'],function(){
            Route::name('relations.create')->get('{video}/relations','VideoRelationsController@create');
            Route::name('relations.store')->post('{video}/relations','VideoRelationsController@store');
            Route::name('uploads.create')->get('{video}/uploads','VideoUploadsController@create');
            Route::name('uploads.store')->post('{video}/uploads','VideoUploadsController@store');
        });
    });
    Route::get('videos/{video}/thumb_asset','VideosController@thumbAsset')->name('videos.thumb_asset');
    Route::get('videos/{video}/thumb_small_asset','VideosController@thumbSmallAsset')->name('videos.thumb_small_asset');
    Route::get('videos/{video}/file_asset','VideosController@fileAsset')->name('videos.file_asset');
    Route::resource('videos','VideosController');
});

app/Models/Video.php
<?php

namespace CodeFlix\Models;

use Bootstrapper\Interfaces\TableInterface;
use CodeFlix\Media\VideoPaths;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Prettus\Repository\Contracts\Transformable;
use Prettus\Repository\Traits\TransformableTrait;

class Video extends Model implements Transformable, TableInterface
{
    use TransformableTrait;
    use SoftDeletes;
    use VideoPaths;

    protected $fillable = [
        'title',
        'description',
        'duration',
        'published',
        'serie_id',
    ];

    protected $casts = [
        'completed' => 'boolean'
    ];

    public function serie()
    {
        return $this->belongsTo(Serie::class);
    }

    public function categories()
    {
        return $this->belongsToMany(Category::class);
    }

    public function getTableHeaders()
    {
        return ['#'];
    }


    public function getValueForHeader($header)
    {
        switch ($header) {
            case '#':
                return $this->id;
        }
    }

}

app/Http/Controllers/Admin/VideosController.php
<?php

namespace CodeFlix\Http\Controllers\Admin;

use CodeFlix\Forms\VideoForm;
use CodeFlix\Http\Controllers\Controller;
use CodeFlix\Http\Controllers\Response;
use CodeFlix\Models\Video;
use Illuminate\Http\Request;

use CodeFlix\Http\Requests;
use Kris\LaravelFormBuilder\Facades\FormBuilder;
use Prettus\Validator\Contracts\ValidatorInterface;
use Prettus\Validator\Exceptions\ValidatorException;
use CodeFlix\Http\Requests\VideoCreateRequest;
use CodeFlix\Http\Requests\VideoUpdateRequest;
use CodeFlix\Repositories\Interfaces\VideoRepository;


class VideosController extends Controller
{

    /**
     * @var VideoRepository
     */
    protected $repository;

    public function __construct(VideoRepository $repository)
    {
        $this->repository = $repository;
    }


    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $videos = $this->repository->paginate();
        return view('admin.videos.index', compact('videos'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $form = FormBuilder::create(VideoForm::class, [
            'url' => route('admin.videos.store'),
            'method' => 'POST'
        ]);

        return view('admin.videos.create', compact('form'));
    }

    public function store()
    {
        $form = FormBuilder::create(VideoForm::class);

        if (!$form->isValid()) {
            return redirect()->back()->withErrors($form->getErrors())->withInput();
        }

        $data = $form->getFieldValues();
        $video = $this->repository->create($data);
        session()->flash('message', 'Video cadastrado com sucesso.');
        return redirect()->route('admin.videos.relations.create',['id'=>$video->id]);
    }

    /**
     * Display the specified resource.
     *
     * @param Video $video
     * @return \Illuminate\Http\Response
     * @internal param Video $video
     * @internal param User $user
     */
    public function show(Video $video)
    {
        return view('admin.videos.show', compact('video'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Video $video
     * @return \Illuminate\Http\Response
     * @internal param Video $video
     * @internal param User $user
     */
    public function edit(Video $video)
    {
        $form = FormBuilder::create(VideoForm::class, [
            'url' => route('admin.videos.update', ['video' => $video->id]),
            'method' => 'PUT',
            'model' => $video
        ]);

        return view('admin.videos.edit', compact('form'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param $id
     * @return \Illuminate\Http\Response
     * @internal param Request $request
     * @internal param User $user
     */
    public function update($id)
    {
        $form = FormBuilder::create(VideoForm::class);

        if (!$form->isValid()) {
            return redirect()->back()->withErrors($form->getErrors())->withInput();
        }

        $data = $form->getFieldValues();
        $this->repository->update($data, $id);
        session()->flash('message', 'Video alterado com sucesso.');
        return redirect()->back();
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param $id
     * @return \Illuminate\Http\Response
     * @internal param User $user
     */
    public function destroy($id)
    {
        $this->repository->delete($id);
        session()->flash('message', 'Video excluído com sucesso.');
        return redirect()->route('admin.videos.index');
    }

    public function fileAsset(Video $video)
    {
        return response()->download($video->file_path);
    }

    public function thumbAsset(Video $video)
    {
        return response()->download($video->thumb_path);
    }

    public function thumbSmallAsset(Video $video)
    {
        return response()->download($video->thumb_small_path);
    }
}

app/Http/Controllers/Api/VideosController.php
<?php

namespace CodeFlix\Http\Controllers\Api;

use CodeFlix\Criteria\FindPublishedAndCompletedCriteria;
use CodeFlix\Http\Controllers\Controller;
use CodeFlix\Models\Video;
use CodeFlix\Repositories\Interfaces\VideoRepository;

class VideosController extends Controller
{
    /**
     * @var VideoRepository
     */
    private $repository;

    public function __construct(VideoRepository $repository)
    {
        $this->repository = $repository;
    }

    public function index()
    {
        $this->repository->pushCriteria(new FindPublishedAndCompletedCriteria());
        return $this->repository->scopeQuery(function($query){
            return $query->take(50);
        })->paginate();
    }

    public function show($id)
    {
        $this->repository->pushCriteria(new FindPublishedAndCompletedCriteria());
        return $this->repository->find($id);
    }
}

resources/views/admin/videos/create.blade.php
@extends('layouts.admin')

@section('content')
<div class="container">
    <div class="row">
        @component('admin.videos.tabs-component')
            <div class="col-md-12">
                <h3>Novo video</h3>
                <?php $icon = Icon::create('floppy-disk'); ?>
                {!! form($form->add('salve','submit',[
                    'attr' => ['class'=>'btn-lg btn btn-primary btn-block','title'=>'Salvar'],
                    'label' => $icon
                ])) !!}
            </div>
        @endcomponent
    </div>
</div>
@endsection

resources/views/admin/videos/edit.blade.php
@extends('layouts.admin')

@section('content')
<div class="container">
    <div class="row">
        @component('admin.videos.tabs-component',['video'=>$form->getModel()])
            <div class="col-md-12">
                <h3>Editar video</h3>
                <?php $icon = Icon::create('pencil'); ?>
                {!! form($form->add('salve','submit',[
                    'attr' => ['class'=>'btn-lg btn btn-primary btn-block','title'=>'Salvar'],
                    'label' => $icon
                ])) !!}
            </div>
        @endcomponent
    </div>
</div>
@endsection

resources/views/admin/videos/index.blade.php
@extends('layouts.admin')

@section('content')
<div class="container">
    <div class="row">
        <h3>Listagem de videos</h3>
        {!! Button::primary('Novo video')->asLinkTo(route('admin.videos.create')) !!}
    </div>
    <div class="row">
        {!!
            Table::withContents($videos->items())->striped()
            ->callback('Descrição', function($field,$video){
                return MediaObject::withContents(
                    [
                        'image' => $video->thumb_small_asset,
                        'link'  => $video->file_asset,
                        'heading'  => $video->title,
                        'body'  => $video->description
                    ]
                );
            })
            ->callback('Ações', function($field,$video){
                $linkEdit = route('admin.videos.edit',['category'=>$video->id]);
                $linkShow = route('admin.videos.show',['category'=>$video->id]);
                return Button::link(Icon::create('pencil'))->asLinkTo($linkEdit)
                    .'|'.
                    Button::link(Icon::create('trash'))->asLinkTo($linkShow);
            })
        !!}
        {!! $videos->links() !!}
    </div>
</div>
@endsection

@push('styles')
<style type="text/css">
    .media-body{
        width: 400px;
    }
</style>
@endpush

resources/views/admin/videos/relation.blade.php
@extends('layouts.admin')

@section('content')
    <div class="container">
        <div class="row">
            @component('admin.videos.tabs-component',['video'=>$form->getModel()])
                <div class="col-md-12">
                    <h3>Série e categorias</h3>
                    <?php $icon = Icon::create('pencil'); ?>
                    {!! form($form->add('salve','submit',[
                        'attr' => ['class'=>'btn-lg btn btn-primary btn-block','title'=>'Salvar'],
                        'label' => $icon
                    ])) !!}
                </div>
            @endcomponent
        </div>
    </div>
@endsection

resources/views/admin/videos/show.blade.php
@extends('layouts.admin')

@section('content')
    <div class="container">
        <div class="row">
            <h3>Visualizar video</h3>
            <?php
            $iconEdit = Icon::create('pencil');
            $iconRemove = Icon::create('trash');
            ?>
            {!! Button::primary($iconEdit)->asLinkTo(route('admin.videos.edit',['video'=>$video->id])) !!}
            {!!
                Button::danger($iconRemove)
                ->asLinkTo(route('admin.videos.destroy',['video'=>$video->id]))
                ->addAttributes(['onclick'=>"event.preventDefault();document.getElementById(\"form-delete\").submit();"])
            !!}
            <?php $formDelete = FormBuilder::plain([
                'id' => 'form-delete',
                'method' => 'DELETE',
                'style' => 'display:none',
                'route'=>['admin.videos.destroy','video'=>$video->id]
            ]);?>
            {!! form($formDelete) !!}
            <br/><br/>

            <table class="table table-bordered">
                <tbody>
                <tr>
                    <th scope="row">Capa</th>
                    <td>
                        <img src="{{$video->thumb_asset}}" height="360">
                    </td>
                </tr>
                <tr>
                    <th scope="row">Video</th>
                    <td>
                        <a href="{{$video->file_asset}}" target="_blank">Download</a>
                    </td>
                </tr>
                <tr>
                    <th scope="row">#</th>
                    <td>{{$video->id}}</td>
                </tr>
                <tr>
                    <th scope="row">Título</th>
                    <td>{{$video->title}}</td>
                </tr>
                <tr>
                    <th scope="row">Descrição</th>
                    <td>{{$video->description}}</td>
                </tr>
                </tbody>
            </table>
        </div>
    </div>
@endsection

resources/views/admin/videos/tabs-component.blade.php
<?php

$tabs = [
    [
        'title' => 'Informações',
        'link' => !isset($video)?route('admin.videos.create'):route('admin.videos.edit',['video'=>$video->id]),
    ],
    [
        'title' => 'Série e categoria',
        'link' => !isset($video)?'#':route('admin.videos.relations.create',['video'=>$video->id]),
        'disabled' => !isset($video)?true:false,
    ],
    [
        'title' => 'Video e capa',
        'link' => !isset($video)?'#':route('admin.videos.uploads.create',['video'=>$video->id]),
        'disabled' => !isset($video)?true:false,
    ],
];

?>
<h3>Gerenciar vídeo</h3>
<div class="text-right">
    {!! Button::link('Listar videos')->asLinkTo(route('admin.videos.index')) !!}
</div>
{!! Navigation::tabs($tabs) !!}
<div>
    {!! $slot !!}
</div>

resources/views/admin/videos/upload.blade.php
@extends('layouts.admin')

@section('content')
    <div class="container">
        <div class="row">
            @component('admin.videos.tabs-component',['video'=>$form->getModel()])
                <div class="col-md-12">
                    <h3>Capa e arquivo de vídeo</h3>
                    <?php $icon = Icon::create('pencil'); ?>
                    {!! form($form->add('salve','submit',[
                        'attr' => ['class'=>'btn-lg btn btn-primary btn-block','title'=>'Salvar'],
                        'label' => $icon
                    ])) !!}
                </div>
            @endcomponent
        </div>
    </div>
@endsection